﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

using Microsoft.VisualBasic;
using System.Diagnostics;


using System.ComponentModel;
using System.Drawing;

public enum EditState
{
    EState_NoObject = 1,
    EState_LoadedObject = 2,
    EState_EditingObject = 3,
    EState_NewObject = 4,
    EState_Readonly = 5
}

public static class WindowsRutiner
{

    public static Wisej.Web.Control FindActiveControl(Wisej.Web.Control F)
    {
        foreach (Wisej.Web.Control C in F.Controls)
        {
            //Is F.ActiveControl Then '  C.Focused Then
            if (C.ContainsFocus)
            {
                //If TypeOf C Is C1.Win.C1FlexGrid.C1FlexGrid Then
                //    Return C
                //Else
                if (C.HasChildren)
                {
                    return FindActiveControl(C);
                }
                else
                {
                    return C;
                }
            }
            else if (C.Focused)
            {
                return C;
            }
        }
        return null;
    }

    public static Wisej.Web.Control FindActiveControl(Wisej.Web.Form F)
    {
        foreach (Wisej.Web.Control C in F.Controls)
        {
            //Is F.ActiveControl Then '  C.Focused Then
            if (C.ContainsFocus)
            {
                //If TypeOf C Is C1.Win.C1FlexGrid.C1FlexGrid Then
                //    Return C
                //Else
                if (C.HasChildren)
                {
                    return FindActiveControl(C);
                }
                else
                {
                    return C;
                }
            }
            else if (C.Focused)
            {
                return C;
            }
        }
        return null;
    }

    private static Wisej.Web.Control GetFocusedControl(Wisej.Web.Control parent)
    {
        if ((parent.Focused))
        {
            return parent;
        }
        foreach (Wisej.Web.Control ctrl in parent.Controls)
        {
            Wisej.Web.Control temp = GetFocusedControl(ctrl);
            if (((temp != null)))
            {
                return temp;
            }
        }
        return null;
    }



    public static void CommitDataboundChangesInForm(Wisej.Web.Form F)
    {
        //Sørge for at alle controller som står i edit modus får lagret verdien
        Wisej.Web.Control C1 = FindActiveControl(F);
        if ((C1 != null))
        {
            if (C1.DataBindings.Count > 0)
            {
                if (C1.DataBindings[0].IsBinding)
                {
                    C1.DataBindings[0].WriteValue();
                }
            }
        }
        //ExitEditModeAllUltragrids(F);
        //ExitEditModeAllXtraGrids(F);

        //SendKeys.Send("{TAB}") 'Liker ikke å bruke SendKeys
        //Application.DoEvents();
    }


    //public static void CommitDataboundChangesInForm(CustomControls.WinPart F)
    //{
    //    //Sørge for at alle controller som står i edit modus får lagret verdien
    //    Control C1 = FindActiveControl(F);
    //    if ((C1 != null))
    //    {
    //        if (C1.DataBindings.Count > 0)
    //        {
    //            if (C1.DataBindings.Item(0).IsBinding)
    //            {
    //                C1.DataBindings.Item(0).WriteValue();
    //            }
    //        }
    //    }
    //    ExitEditModeAllUltragrids(F);
    //    ExitEditModeAllXtraGrids(F);
    //    Application.DoEvents();
    //}


    ///// <summary>
    ///// Setter alle kontroller uten Tag="XX" readonly=True/False
    ///// </summary>
    ///// <param name="Value">Ved 'True' settes alle til ReadOnly/NotEnabled, ReadWrite/Enabled ellers </param>
    ///// <remarks></remarks>
    //public static void SetReadOnly(ref System.Windows.Forms.Control.ControlCollection x, bool Value)
    //{

    //    foreach (Control i in x)
    //    {

    //        if (i.GetType.ToString == "System.Windows.Forms.TextBox")
    //        {
    //            if (!(i.Tag == "XX"))
    //            {
    //                ((System.Windows.Forms.TextBox)i).ReadOnly = Value;
    //            }
    //        }
    //        else if (i.GetType.ToString == "System.Windows.Forms.CheckBox")
    //        {
    //            if (!(i.Tag == "XX"))
    //            {
    //                ((System.Windows.Forms.CheckBox)i).Enabled = !Value;
    //            }
    //        }
    //        else if (i.GetType.ToString == "System.Windows.Forms.DateTimePicker")
    //        {
    //            if (!(i.Tag == "XX"))
    //            {
    //                ((System.Windows.Forms.DateTimePicker)i).Enabled = !Value;
    //            }
    //        }
    //        else if (i.GetType.ToString == "System.Windows.Forms.ComboBox")
    //        {
    //            if (!(i.Tag == "XX"))
    //            {
    //                ((System.Windows.Forms.ComboBox)i).Enabled = !Value;
    //            }
    //        }
    //        else if (i.GetType.ToString == "System.Windows.Forms.DataGridView")
    //        {
    //            if (!(i.Tag == "XX"))
    //            {
    //                ((System.Windows.Forms.DataGridView)i).Enabled = !Value;
    //            }
    //        }
    //        else if (i.GetType.ToString == "Infragistics.Win.UltraWinGrid.UltraGrid")
    //        {
    //            if (!(i.Tag == "XX"))
    //            {
    //                //CType(i, Infragistics.Win.UltraWinGrid.UltraGrid).Enabled = Not Value
    //                i.GetType().GetProperty("Enabled").SetValue(i, !Value, null);
    //            }
    //        }
    //        else if (i.GetType.ToString == "System.Windows.Forms.RadioButton")
    //        {
    //            if (!(i.Tag == "XX"))
    //            {
    //                ((System.Windows.Forms.RadioButton)i).Enabled = !Value;
    //            }
    //        }
    //        else if (i.GetType.ToString == "System.Windows.Forms.Button")
    //        {
    //            if (!(i.Tag == "XX"))
    //            {
    //                ((System.Windows.Forms.Button)i).Enabled = !Value;
    //            }
    //        }
    //        else if (i.GetType.ToString == "DevExpress.XtraGrid.GridControl")
    //        {
    //            if (!(i.Tag == "XX"))
    //            {
    //                //CType(i, DevExpress.XtraGrid.GridControl).Enabled = Not Value
    //                ((DevExpress.XtraGrid.Views.Grid.GridView)((DevExpress.XtraGrid.GridControl)i).MainView).OptionsBehavior.ReadOnly = Value;
    //            }
    //            //ElseIf i.GetType.ToString = " DevExpress.XtraGrid.Views.Grid.GridView" Then
    //            //    If Not i.Tag = "XX" Then
    //            //        CType(i, DevExpress.XtraGrid.Views.Grid.GridView).OptionsBehavior.Editable = Not Value
    //            //    End If
    //        }
    //        if ((i.Controls != null))
    //        {
    //            SetReadOnly(ref i.Controls, Value);
    //        }

    //    }

    //}


    public static void SetCurrentRowInBindingSource(Wisej.Web.BindingSource bs, object Row)
    {
        int index = 0;
        foreach (var o_loopVariable in bs.List)
        {
            var o = o_loopVariable;
            if (object.ReferenceEquals(o, Row))
            {
                bs.Position = index;
                break; // TODO: might not be correct. Was : Exit For
            }
            index = index + 1;
        }
    }

    public static void SetCurrentRowInBindingSource(Wisej.Web.BindingSource bs, string PropertyName, object key)
    {
        int pos = bs.Find(PropertyName, key);
        bs.Position = pos;
    }


    /// <summary>
    /// Sjekker om Tag inneholder en streng.
    /// F.eks TagHas(t,"READONLY,RED") sjekker om t inneholder forekomst av "READONLY" eller "RED"
    /// </summary>
    private static bool TagHas(object Tag, string tags)
    {
        if ((Tag != null))
        {
            string[] tagsarray = tags.ToUpper().Split(',');
            string pTag = Tag.ToString().ToUpper();
            foreach (string s in tagsarray)
            {
                if (pTag.Contains(s))
                {
                    return true;
                }
            }
        }
        return false;
    }


    private static void SetSingleControlState(Wisej.Web.Control i, EditState EditState, bool DisableControl)
    {
        if (i.GetType().ToString() == "Wisej.Web.ToolBar")
        {
            Wisej.Web.ToolBar toolstrip = (Wisej.Web.ToolBar)i;
            foreach (Wisej.Web.ToolBarButton ibutton in toolstrip.Buttons)
            {
                if(ibutton.Style != Wisej.Web.ToolBarButtonStyle.Separator)
                {
                    if (!TagHas(ibutton.Tag, "IGNORE"))
                    {
                        if (TagHas(ibutton.Tag, "ONSELECTED") && EditState == EditState.EState_LoadedObject)
                        {
                            ibutton.Enabled = true;
                        }
                        else
                        {
                            ibutton.Enabled = !DisableControl;
                        }
                    }

                    if (TagHas(ibutton.Tag, "HIDEONEDIT"))
                    {
                        if ( (EditState == EditState.EState_EditingObject | EditState == EditState.EState_NewObject))
                        {
                            ibutton.Visible = false;
                        }
                        else
                        {
                            ibutton.Visible = true;
                        }
                    }

                    else if (TagHas(ibutton.Tag, "SHOWONEDIT"))
                    {
                        if ((EditState == EditState.EState_EditingObject | EditState == EditState.EState_NewObject))
                        {
                            ibutton.Visible = true;
                        }
                        else
                        {
                            ibutton.Visible = false;
                        }
                    }

                    if (TagHas(ibutton.Tag, "INVISIBLE"))
                    {
                        ibutton.Visible = false;
                    }

                }
            }
        }
        else if (i.GetType().ToString() == "Wisej.Web.TextBox")
        {
            ((Wisej.Web.TextBox)i).ReadOnly = DisableControl;
        }
        else if (i.GetType().ToString() == "Wisej.Web.CheckBox")
        {
            ((Wisej.Web.CheckBox)i).Enabled = !DisableControl;
        }
        else if (i.GetType().ToString() == "Wisej.Web.DateTimePicker")
        {
            ((Wisej.Web.DateTimePicker)i).Enabled = !DisableControl;
        }
        else if (i.GetType().ToString() == "Wisej.Web.ComboBox")
        {
            ((Wisej.Web.ComboBox)i).Enabled = !DisableControl;
        }
        else if (i.GetType().ToString() == "Wisej.Web.DataGridView")
        {
            if (TagHas(i.Tag, "OFFEDIT"))
            {
                ((Wisej.Web.DataGridView)i).Enabled = !DisableControl;
            }
            ((Wisej.Web.DataGridView)i).ReadOnly = DisableControl;
        }
        else if (i.GetType().ToString() == "Wisej.Web.RadioButton")
        {
            ((Wisej.Web.RadioButton)i).Enabled = !DisableControl;

        }
        else if (i.GetType().ToString() == "Wisej.Web.Button")
        {
            ((Wisej.Web.Button)i).Enabled = !DisableControl;
        }

    }

    /// <summary>
    /// Setter alle kontroller basert på EditState.
    /// Det kan overstyres ved å sette tag feltet.
    /// IGNORE : Ignorer kontroll.
    /// OFFEDIT : Disablet ved edit. Typisk hovedlisten. (NB For DevExpress grid, se heller GridView1_BeforeLeaveRow event)
    /// ONSELECTED : På når record er valgt men ikke i editmode. Typisk Søk knappen.
    /// </summary>
    /// <param name="EditState"></param>
    /// <remarks></remarks>
    public static void SetControlsState(System.Windows.Forms.Control.ControlCollection x, EditState EditState)
    {

        foreach (Wisej.Web.Control i in x)
        {
            if (!TagHas(i.Tag, "IGNORE"))
            {
                bool DisableControl = true;
                if (EditState == EditState.EState_EditingObject)
                {
                    DisableControl = false;
                }
                else if (EditState == EditState.EState_NewObject)
                {
                    DisableControl = false;
                }
                if (TagHas(i.Tag, "ONSELECTED"))
                {
                    if (EditState == EditState.EState_LoadedObject)
                    {
                        DisableControl = false;
                    }
                    else
                    {
                        DisableControl = true;
                    }
                }
                if (TagHas(i.Tag, "OFFEDIT") && (EditState == EditState.EState_EditingObject | EditState == EditState.EState_NewObject))
                {
                    DisableControl = true;
                }
                else if (TagHas(i.Tag, "OFFEDIT"))
                {
                    DisableControl = false;
                }

                SetSingleControlState(i, EditState, DisableControl);

                if (!(i is Wisej.Web.Control))
                {
                    Debug.Print(i.GetType().ToString());
                }
            }

            if(i.Controls != null)
            {
                SetControlsState(i.Controls, EditState);
            }
        }

    }

    public static void AdjustFormPosition(Wisej.Web.Form thisform)
    {
        bool finished = false;
        while (!finished)
        {
            finished = true;
            foreach (Wisej.Web.Form form in Wisej.Web.Application.OpenForms)
            {
                if (form != thisform)
                {
                    if (form.Top == thisform.Top && form.Left == thisform.Left)
                    {
                        thisform.Top += 20;
                        thisform.Left += 20;
                        finished = false;
                    }
                }
            }
        }
    }

}